/* MOST UPDATED CODE
  RECEIVES TARGET TEMP VALUE
  SENDS STATUS
*/
#include <Servo.h>
#include <DHT.h>
//servo things
Servo myservo;  // create servo object to control a servo
int pos = myservo.read();    // variable to store the servo position
//booleans
bool openWindow;
bool oldWindow;

//tempsensor things
#define DHT1_PIN 2     // Digital pin connected to the DHT sensor INSIDE
#define DHT2_PIN 4  //OUTSIDE
#define DHTTYPE DHT11   // DHT 11
DHT dht1(DHT1_PIN, DHTTYPE);
DHT dht2(DHT2_PIN, DHTTYPE);

//variables for sensor values
int inside_temp = 30;
int prev_inside_temp;
int outside_temp = 10;
int prev_outside_temp;
int outside_humidity;
int prev_outside_humidity;
//status variable thats send to processing
int status;
//received by processing
int target_temp;
//test pins
int red = 9;
int green = 8;
int target = 12;

void setup ( ) {
  Serial.begin(9600);       // Starting the serial communication at 9600 baud rate
  //start things need for the DHT sensors
  dht1.begin();
  dht2.begin();
  myservo.attach(7);  // attaches the servo on pin 7 to the servo object
  pinMode(13, OUTPUT); // what is thIS PIN AGAIN?
  //    digitalWrite(13,HIGH);
  pinMode(red, OUTPUT);
  pinMode(green, OUTPUT);
  pinMode(target, OUTPUT);
}

void loop ( ) {
  while (Serial.available() > NULL) { //if there is data available serial read
    target_temp = int(Serial.read()); // reads target_temp from processing to arduino
  }
  /* !!!!!!!!!!!!!!!problem with temp is that is is sending unsigned values so 255 instead of -1 !!!!!!!!!*/
  if (target_temp >= 5) { // test communication from target temperature
    digitalWrite(target, HIGH); // test to see if communication is working
  } else (target, LOW);

  /*-----------------------------UNCOMMMEND---------------*/
  //reading values temp and humidity
  //    inside_temp = dht1.readTemperature(); // inside temp
  //    outside_temp = dht2.readTemperature(); // outside temp
  outside_humidity = dht2.readHumidity(); //outside humidity

  /*-------------------- BEGIN only sends data when date changes -----------*/
  if (inside_temp != prev_inside_temp) {
    Serial.print('F');
    Serial.println(inside_temp); // settemp is temp inside
    prev_inside_temp = inside_temp;
  }

  if (outside_temp != prev_outside_temp) {
    Serial.print('Z');
    Serial.println(outside_temp);
    prev_outside_temp = outside_temp;
  }

  if (outside_humidity !=  prev_outside_humidity) {
    Serial.print('H');
    Serial.println(outside_humidity); // sending humidity to processing
    prev_outside_humidity = outside_humidity;
  }
  Serial.print('s'); // s for status STILL HAVE TO TO WITH PREV STATUS
  Serial.println(status); // sensding window status
  /*-------------DEBUG---------*/
  //  Serial.print("boolean");
  //  Serial.println(openWindow);
  //  Serial.print("target ");
  //  Serial.println(target_temp);
  /*-------------DEBUG---------*/
  /*--------------------------------//one time ,2 sec after starting to get rid of the start up values------------*/
  if (millis() < 1999) {
    Serial.print('F');
    Serial.println(inside_temp); // settemp is temp inside
    Serial.print('Z');
    Serial.println(outside_temp);
    Serial.print('H');
    Serial.println(outside_humidity); // sending humidity to processing
  }
  /*-------------------- END only sends data when date changes-----------*/

  /*--------begin window code--------------------*/
  Window();
  //window code
  if (abs(inside_temp - target_temp) > 2) { // checks if there is a significant difference in temperature
    if (inside_temp > target_temp) {//is it hotter than desired
      if (outside_temp > inside_temp) { //if it's hotter outside, close the window
        if (openWindow) {
          openWindow = false;
        }
      } else {// if its colder outside, open the window
        if (!openWindow) {
          openWindow = true;
        }
      }
    } else { // is it colder than desired
      if (outside_temp > inside_temp) {//if it's hotter outside, open the window
        if (!openWindow) {
          openWindow = true;
        }
      } else {//if its colder outside, close the window
        if (openWindow) {
          openWindow = false;
        }
      }
    }
  }
}
/*--------end window code--------------------*/

void Window() {
  if (openWindow != oldWindow) { // when the value is the same window code will not open or close again if its already closed or openen
    oldWindow = openWindow;
    if (openWindow) { //open
      //PASTE WINDOW OPEN CODE
      myservo.write(180);  //open window
      delay(750);
      //      myservo.write(90);
      delay(500);
      digitalWrite(green, HIGH);
      digitalWrite(red, LOW);
      status = 0;
    } else if (!openWindow) {
      digitalWrite(green, LOW);
      digitalWrite(red, HIGH);
      myservo.write(0);     //close window
      delay(740);
      status = 1;
      for (int x = 0; x < 1; x++) { // warning system (led blinking) to warn that window is closing
        digitalWrite(13, HIGH);
        delay(500);
        digitalWrite(13, LOW);
        delay(500);
      }
    }
    //    myservo.write(90);
    //        while (1) {} //stop after 1 time
  }
}
